###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
# Copyright (c) 2006 Mehdi Abaakouk
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###




import gtk
import gobject
import os
import gnomevfs

import stock
import utils
import const
import utils
import config

from time import time,sleep



from  _source import Source,SourceItem,PlaylistSourceItem
from library import *
from widget.dialog import WindowBase
from widget.browser import Browser
from widget.song_view import SortableSongView,SongView,PlaylistSongView
from widget.song_menu import SongMenu
from widget.progress import action_progress    
from widget.misc import ScrolledWindow
from helper import helper
from song import Song,READ_EXTENTIONS
from hal import hal

from transcode import Transcoder



    
class ArchosSource(Source):
    def __init__(self,player):
        Source.__init__(self,player)

        self.player = player
        self.Archos_librarys = []
        self.Archos_items = {}
        
        helper.connect("playlist-added",self.add_playlist)
        helper.connect("playlist-removed",self.remove_playlist)

    def add_playlist(self,helper,pl):
        for l in self.Archos_librarys:    
            if pl.codeName != l.codeName or pl.library.udi != l.udi: return
            pl_view = PlaylistSongView(l,pl)
            pl_item = ArchosPlaylistSourceItem(self.player,pl,stock.SRC_PLAYLIST_Archos,pl.name,ScrolledWindow(pl_view),"Archos")
            self.Archos_items[l.udi].append(pl_item)
            pl_view.get_model().fill(pl.get_songs())
            self.build_source_items()

        
    def remove_playlist(self,helper,pl):
        for l in self.Archos_librarys:        
            if pl.codeName != l.codeName  or pl.library.udi != l.udi : return    
            self.Archos_items[l.udi] = [item for item in self.Archos_items[l.udi] if not isinstance(item,ArchosPlaylistSourceItem) or item.pl!=pl]
            self.build_source_items() 
                    
    def get_default_menu(self):
        def new_playlist(w,l):
            l.add_playlist(ArchosPlaylist(l,_("New Playlist")))
            
        def new_smart_playlist(w,l):
            pass    
        
        factory = gtk.IconFactory()
        items = []
        items.append(gtk.SeparatorMenuItem())
        for l in self.Archos_librarys:
            pl_stock = "Archos-pl-"+l.get_pl_master().name
            pl_smart_stock = "Archos-smart-pl-"+l.get_pl_master().name
            icons = gtk.IconFactory()
            icons.add(pl_stock, gtk.icon_factory_lookup_default(stock.SRC_PLAYLIST_Archos))
            icons.add(pl_smart_stock, gtk.icon_factory_lookup_default(stock.SRC_PLAYLIST_SMART))
            icons.add_default()
            
            gtk.stock_add([
            (pl_stock, _("_New Archos (%s) Playlist")%l.get_pl_master().name, 0, 0, ""),
            (pl_smart_stock,  _("_New Archos (%s) _Automatique Playlist...")%l.get_pl_master().name, 0, 0, "")
            ])
            item1 = gtk.ImageMenuItem(pl_stock)
            item1.connect("activate",new_playlist,l)
            item2 = gtk.ImageMenuItem(pl_smart_stock)
            item2.connect("activate",new_smart_playlist,l)
            items.append(item1)
            items.append(item2)
        return items
            
        
    def check(self,hal,udi):
        print udi
        prop = hal.get_property(udi)    
        if prop.has_key("info.parent") and prop.has_key("info.parent")!="":
            prop2 = hal.get_property(prop["info.parent"])
            if prop2.has_key("storage.model") and prop2["storage.model"]=="iPod":
               return True
        return False  
    
        print udi
        prop = hal.get_property(udi)
        if prop.has_key("storage.model") and prop["storage.model"].rfind("Archos")==0:
           return True
        return False  
    
    def mount(self,hal,udi):
        m = hal.get_mount_point(udi)
        print "Archos mounted at ",m

        Archos_library = ArchosLibrary(m,udi)
        if Archos_library.load():
            Archos_library.load_library()    
            paned_browser = ArchosBrowser(Archos_library)
            paned_browser_item = ArchosLibrarySourceItem(self.player,Archos_library.get_pl_master(),stock.SRC_Archos,utils.xmlescape(Archos_library.get_pl_master().name),paned_browser,"Archos")
            self.Archos_items.setdefault(udi,[]).append(paned_browser_item)
            
            for pl in Archos_library.get_pl_normal():
                pl_view = PlaylistSongView(Archos_library,pl)
                pl_item = ArchosPlaylistSourceItem(self.player,pl,stock.SRC_PLAYLIST_Archos,pl.name,ScrolledWindow(pl_view),"Archos")
                self.Archos_items[udi].append(pl_item)
                pl_view.get_model().fill(pl.get_songs())
                
            paned_browser.populate()
            self.build_source_items()
            
        self.Archos_librarys.append(Archos_library)
           
    def umount (self,hal,udi):
        if self.Archos_items.has_key(udi):
            del self.Archos_items[udi]
            self.build_source_items()
    
    def load(self,player):
        try: import gpod
        except : pass
        else: hal.register_volume(self.check,self.mount,self.umount)
        
    def build_source_items(self):
        self.items = []
        for udi,items in self.Archos_items.iteritems():
            self.items.extend(items)
        helper.update_source()
        
            
        
class ArchosBrowser(Browser):
    def __init__(self,library):
        super(ArchosBrowser,self).__init__(library)
        self.set_song_treeview(ArchosSongView(library))
        self.treeviews["songs"].set_sort_by(None,"album", gtk.SORT_ASCENDING, False)

        menu = SongMenu(library,True,True,True,False,True,False)
        menu.show_all()
        self.set_menu(menu)
        

class ArchosPlaylistSourceItem(PlaylistSourceItem):
    def on_edition(self,new_text):
        self.pl.Archos_pl.name = str(new_text)
        return PlaylistSourceItem.on_edition(self,new_text)
    

        
class ArchosLibrarySourceItem(ArchosPlaylistSourceItem):
    has_top_separateur = True
   
    def on_drag_song_received(self,songs):
        self.pl.append(songs)
        return False 
    
    def get_menu(self):
        menu = gtk.Menu()
        def new_playlist(w):
            self.pl.library.add_playlist(ArchosPlaylist(self.pl.library,_("New Playlist")))

        l = self.pl.library
        pl_stock = "Archos-pl-"+l.get_pl_master().name
        icons = gtk.IconFactory()
        icons.add(pl_stock, gtk.icon_factory_lookup_default(stock.SRC_PLAYLIST))
        icons.add_default()
        
        gtk.stock_add([
        (pl_stock, _("_New Archos (%s) Playlist")%l.get_pl_master().name, 0, 0, ""),
        ])
        item = gtk.ImageMenuItem(pl_stock)
        item.connect("activate",new_playlist)
        menu.append(item)
        item = gtk.ImageMenuItem(pl_smart_stock)
        item.connect("activate",new_smart_playlist)
        menu.append(item)
        menu.append(gtk.SeparatorMenuItem())
        item = gtk.ImageMenuItem(stock.RENAME)
        item.connect("activate",self.edit_playlist)
        menu.append(item)
        item = gtk.ImageMenuItem(gtk.STOCK_PROPERTIES)
        item.connect("activate",self.show_property)
        menu.append(item)
        menu.show_all()
        return menu
    
    def show_property(self,w):
        dialog = WindowBase(_("Archos Property"),const.PIXMAP_DIR+"/Archos_big.png",(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE,))

        prop = hal.get_property(self.pl.library.udi)   
        dialog.label_heading.set_markup("<span size=\"large\"><b>Archos "+self.pl.library.Archos_version+" ("+utils.str_size(prop["volume.size"] ,0,1000)+")</b></span>")
        hbox = gtk.HBox(0,6)
        l = gtk.Label(_("Name")+" : "+utils.xmlescape(self.pl.name))
        #l.set_alignement(0,0.5)
        hbox.pack_start(l)

        used = utils.du(self.pl.library.mount_point)
        
        free = prop["volume.size"] - used

        frac = float(used) / float(prop["volume.size"])
        progress = gtk.ProgressBar()
        progress.set_fraction(frac)
        progress.set_text("%s Free space"%utils.str_size(used,1))
        dialog.add_widget(hbox)
        dialog.add_widget(progress)
        dialog.show_all()
        dialog.run()
        dialog.destroy()
    
class ArchosSongView(SortableSongView):
    def __init__(self,library):
        super(ArchosSongView,self).__init__(library,gobject.TYPE_STRING,gobject.TYPE_STRING,gobject.TYPE_STRING,gobject.TYPE_STRING,gobject.TYPE_STRING)

        self.set_column_tags("#track","title","#duration","album","artist")
        self.append_column_by_tag("#track",1)
        self.append_column_by_tag("title",2)
        self.append_column_by_tag("#duration",3)
        self.append_column_by_tag("album",4)
        self.append_column_by_tag("artist",5 )     
        
        menu = SongMenu(library,True,True,True,False,True,False)
        menu.show_all()
        self.set_menu(menu)
        
        
class ArchosPlaylist(Playlist):
    def __init__(self,library,name):
        Playlist.__init__(self,library,name,PL_NORMAL)
        
    def append(self,songs):
        added = Playlist.append(self,songs)
        for s in added:
            track = self.library.archos_track[s.get("uri")]
            gpod.itdb_playlist_add_track(self.Archos_pl, track,-1)
        return added
            
    def insert(self,songs,init_pos):
        added = Playlist.append(self,songs)
        pos = init_pos
        for s in added:
            track = self.library.archos_track[s.get("uri")]
            gpod.itdb_playlist_add_track(self.Archos_pl, track,pos)
            pos += 1
        
    def remove_songs(self,songs):
        removed = Playlist.remove_songs(self,songs)    
        for s in removed:
            track = self.library.archos_track[s.get("uri")]
            gpod.itdb_playlist_remove_track(self.Archos_pl, track)
        
class ArchosLibrary(Library):
    itdb = None
    def __init__(self,mount_point,udi):
        Library.__init__(self,"Archos")
        self.udi = udi
        self.mount_point = mount_point
        self.db = os.path.join(self.mount_point,"Archos_Control/iTunes/iTunesDB")
        self.sysinfo_path = os.path.join(self.mount_point, 'Archos_Control', 'Device', 'SysInfo')
        self.archos_track = {}
        
        self.Archos_version =_("Unknown")
        
        self.init_Archos_model_info()
        
        self.__song_in_transfer = []
        self.__current_transcode = None
           
           
    def load(self):
        mount_point = str(self.mount_point)
        self.itdb = gpod.itdb_parse(mount_point, None)
        if not self.itdb:
            print "Failed to read %s" % self.db
            return self.create_Archos_structure()
        else:
            """ check podcast playlist exsist and create it if not """
            if self.check_Archos_structure():
                return True
            else:
                print "Failed create master and podcast playlist"
    
    def save(self):
        print "Save Archos database"
        #print "Write Archos DB",mount_point
        if gpod.itdb_write(self.itdb, None)==0:
            print "Failed to save Archos database"
        else:
            #print "Write Shuffle Archos DB",mount_point
            if gpod.itdb_shuffle_write(self.itdb, None)==0:
                print "Failed to save Archos database"
                
    
    def get_song_on_Archos(self,song):
        for s in self.songs.values():
            if s.get("#duration") != song.get("#duration"):
                continue    
            elif s.get("title") != song.get("title"):
                continue
            elif s.get("artist") != song.get("artist"):
                continue
            elif s.get("album") != song.get("album"):
                continue
            else:
                return s
        return None
    
    def background_add(self,songs):
        total = len(songs)
        i = 0
        added = []
        new_songs = []
        for song in songs:
            i += 1
            uri = song.get("uri")
            if not uri in self.archos_track.keys() and self.get_song_on_Archos(song)==None:
                if song.get_ext() != ".mp3":
                    try: gnomevfs.unlink("file:///tmp/listentmp.mp3")
                    except: pass
                    self.__current_transcode = Transcoder(uri,"file:///tmp/listentmp.mp3")
                    while not self.__current_transcode.is_finish():
                        sleep(0.1)
                        yield _("Adding file")+" %d/%d..."%(i,total)+" Encoding... (%d%%)"%self.__current_transcode.get_ratio(),float(i)/float(total),False    
                    song["uri"] = "file:///tmp/listentmp.mp3"
                                    
                track.itdb = self.itdb
                gpod.itdb_cp_track_to_Archos(track,str(song.get_path()),None)
                gpod.itdb_track_add(self.itdb,track,-1)
                
                uri = song.get("uri")
                self.songs[uri] = song
                self.archos_track[uri] = track
                added.append(song)
            new_songs.append(song)
                
            yield _("Adding file")+" %d/%d..."%(i,total),float(i)/float(total),False
        self.__song_in_transfer = new_songs
        if len(added)>0: helper.add_songs(added)
            
        
    def add_songs(self,songs):
        id = action_progress.add_queue("Loading...",self.background_add,songs)
        action_progress.wait_task(id)
        print "stop"
        if self.__current_transcode:
            self.__current_transcode.stop()
        self.__current_transcode = None
        songs = self.__song_in_transfer
        self.__song_in_transfer = []
        return songs
        
    def delete_songs(self,songs):
        deleted = []    
        for pl in self.playlists:
            pl.remove_songs(songs)
            
        for song in songs:
            uri = song["uri"]
            if self.songs.has_key(uri):
                gpod.itdb_track_unlink(self.archos_track[uri])
                del self.songs[uri]
                del self.archos_track[uri]
                deleted.append(song)
                
        if len(deleted)>0: helper.delete_songs(deleted)
        return deleted
        
    def add_playlist(self,playlist):
        gpod.itdb_playlist_add(self.itdb,playlist.Archos_pl,-1)
        super(ArchosLibrary,self).add_playlist(playlist)    
        
        
    def delete_playlist(self,playlist):
        gpod.itdb_playlist_remove(playlist.Archos_pl)
        super(ArchosLibrary,self).delete_playlist(playlist)
        
        
    def load_library(self):
                

        for track in gpod.sw_get_tracks(self.itdb):
            song = track_to_song(track)
            self.songs[song.get("uri")] = song
                    
        for playlist in gpod.sw_get_playlists(self.itdb):
            pl = ArchosPlaylist(self,playlist.name,playlist)
            pl.codeName = self.codeName
            self.playlists.append(pl)
            for track in gpod.sw_get_playlist_tracks(playlist):
                song = track_to_song(track)    
                pl.songs.append(song.get("uri"))
                
        print "----- Archos -----"
        print len(self.songs),"songs and",len(self.playlists),"playlists loaded"
        for pl in self.playlists:
            print len(pl.songs)," in pl ",pl.name
           
           
           

    
    
    
           